---
title: revert
slug: Web/CSS/revert
tags:
  - CSS
  - CSS Cascade
  - CSS Value
  - Cascade
  - Keyword
  - Layout
  - Reference
  - Style
  - revert
---
<div>{{CSSRef}}</div>

<p><span class="seoSummary">The <strong><code>revert</code></strong> CSS keyword reverts the cascaded value of the property from its current value to the value the property would have had if no changes had been made by the current <strong>{{Glossary("style origin")}}</strong> to the current element.</span> Thus, it resets the property to its inherited value if it inherits from its parent or to the default value established by the user agent's stylesheet (or by user styles, if any exist). It can be applied to any CSS property, including the CSS shorthand {{cssxref("all")}}.</p>

<p>This removes from the cascade all of the styles that have been overridden until the style being rolled back to is reached.</p>

<ul>
 <li>If used by a site's own styles (the author origin), <code>revert</code> rolls back the property's cascaded value to the user's custom style, if one exists; otherwise, it rolls the style back to the user agent's default style.</li>
 <li>If used in a user's custom stylesheet, or if the style was applied by the user (the user origin), <code>revert</code> rolls back the cascaded value to the user agent's default style.</li>
 <li>If used within the user agent's default styles, this keyword is functionally equivalent to {{cssxref("unset")}}.</li>
</ul>

<p>The <code>revert</code> keyword works exactly the same as <code><a href="/en-US/docs/Web/CSS/unset">unset</a></code> in many cases. The only difference is for properties that have values set by the browser or by custom stylesheets created by users (set on the browser side).</p>

<p>Revert will not affect rules applied to children of an element you reset (but will remove effects of a parent rule on a child). So if you have a <code>color: green</code> for all sections and <code>all: revert</code> on a specific section the color of the section will be black. But if you have a rule to make all paragraphs red then all paragraphs will still be red in all sections.</p>

<div class="notecard note">
<p>Revert is just a value. It is still possible to override <code>revert</code> value using <a href="/en-US/docs/Web/CSS/Specificity">specificity</a>.</p>
</div>

<div class="note">
<p>The <code>revert</code> keyword is different from and should not be confused with {{cssxref("initial")}}, which uses the <a href="/en-US/docs/Web/CSS/initial_value">initial value</a> defined on a per-property basis by the CSS specifications. In contrast, user-agent stylesheets set default values on the basis of CSS selectors.</p>

<p>For example, the <a href="/en-US/docs/Web/CSS/initial_value">initial value</a> for the {{cssxref("display")}} property is <code>inline</code>, whereas a normal user-agent stylesheet sets the default {{cssxref("display")}} value of {{HTMLElement("div")}}s to <code>block</code>, of {{HTMLElement("table")}}s to <code>table</code>, etc.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Revert_vs_unset">Revert vs unset</h3>

<p>Although <code>revert</code> and <code>unset</code> are similar they differ for some properties for some elements.</p>

<p>So in the below example, we set custom <code>font-weight</code> in a global stylesheet, but then try to unset and revert. Unset will keep the text normal because this is an initial value for font-weight property. Revert will revert to bold because this is a default value for headers in most browsers.</p>

<pre class="brush: css notranslate">h3 {
  font-weight: normal;
  color: blue;
}</pre>

<pre class="brush: html notranslate">&lt;h3 style="font-weight: unset; color: unset;"&gt;This will still have font-weight: normal, but color: black&lt;/h3&gt;
&lt;p&gt;Just some text&lt;/p&gt;
&lt;h3 style="font-weight: revert; color: revert;"&gt;This should have its original font-weight (bold) and color: black&lt;/h3&gt;
&lt;p&gt;Just some text&lt;/p&gt;</pre>

<p>{{EmbedLiveSample('Revert_vs_unset')}}</p>

<h3 id="Revert_all">Revert all</h3>

<p>Reverting all values is useful when you did heavy modifications for something and then want to revert to defaults. So to iterate on above example instead of reverting font-weight and color separately you could just revert all of them.</p>

<pre class="brush: css notranslate">h3 {
  font-weight: normal;
  color: blue;
  border-bottom: 1px solid grey;
}</pre>

<pre class="brush: html notranslate">&lt;h3&gt;This will have custom styles&lt;/h3&gt;
&lt;p&gt;Just some text&lt;/p&gt;
&lt;h3 style="all: revert"&gt;This should be reverted to browser/user defaults&lt;/h3&gt;
&lt;p&gt;Just some text&lt;/p&gt;</pre>

<p>{{EmbedLiveSample('Revert_all')}}</p>

<h3 id="Revert_on_a_parent">Revert on a parent</h3>

<p>Reverting effectively removes the value for the element you select with some rule and only for that element. To illustrate this we will set a green color on a section and red color on a paragraph.</p>

<pre class="brush: css notranslate">section { color: darkgreen }
p { color: red }
section.with-revert { color: revert }
</pre>

<pre class="brush: html notranslate">&lt;section&gt;
  &lt;h3&gt;This will be dark green&lt;/h3&gt;
  &lt;p&gt;Text in paragraph will be red.&lt;/p&gt;
  This will also be dark green.
&lt;/section&gt;
&lt;section class="with-revert"&gt;
  &lt;h3&gt;This will be black&lt;/h3&gt;
  &lt;p&gt;Text in paragraph will be red.&lt;/p&gt;
  This will also be black.
&lt;/section&gt;</pre>

<p>Notice how paragraph still has a red color even though a color property for the section was reverted. Also note that both the header and plain text node is black. This is exactly the same as if <code>section { color: darkgreen }</code> would not exist for the second section.</p>

<p>{{EmbedLiveSample('Revert_on_a_parent')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS4 Cascade', '#default', 'revert')}}</td>
   <td>{{Spec2('CSS4 Cascade')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>
<div>

<p>{{Compat("css.types.global_keywords.revert")}}</p>
</div>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>Use {{cssxref("initial")}} to set a property to its initial value.</li>
 <li>Use {{cssxref("unset")}} to set a property to its inherited value if it inherits, or to its initial value if not.</li>
 <li>Use {{cssxref("inherit")}} to make an element's property the same as its parent.</li>
 <li>The {{cssxref("all")}} property lets you reset all properties to their initial, inherited, reverted, or unset state at once.</li>
</ul>
